#!/usr/bin/env escript
-mode(compile).

%%
%% squid url rewriter
%%

main(_) ->
	error_logger:tty(false),
	Sender = spawn(fun sender/0),
	receiver(Sender).

sender() ->
	receive
		quit -> ok;
		{put, S} ->
			io:format("~s", [S]),
			sender()
	end.

receiver(Sender) ->
	case io:get_line('') of
		eof ->
			Sender ! quit,
			halt(0);
		String ->
			spawn(fun() -> worker(Sender, String) end),
			receiver(Sender)
	end.

worker(Sender, String) ->
	[ID, URL, _Client, _User, _Method, _URLGroup|_] = string:tokens(String, " "),
	
	%% this computation takes really long
	timer:sleep(5000),
	
	NewURL = case URL of
		[$h,$t,$t,$p,$s,$:,$/,$/|_] -> URL;
		_ -> "about:insecure"
	end,
	
	Sender ! {put, lists:flatten(io_lib:format("~s ~s~n", [ID, NewURL]))}.

